#define UTF8_RUSSIAN_SUPPORT

// MCP23x17_patch
/* //removed
#include "LiquidCrystal.h"
*/
#include <LiquidCrystal_MCP23x17.h>
// /MCP23x17_patch

#include <stdio.h>
#include <string.h>
#include <inttypes.h>
// MCP23x17_patch
/* //removed
#include "Arduino.h"
*/
#if defined(ARDUINO) && ARDUINO >= 100
#include "Arduino.h"
#else
#include "WProgram.h"
#endif

#if defined(UTF8_RUSSIAN_SUPPORT)
#include <avr/pgmspace.h>
PROGMEM const prog_uchar _utf8_ru_table[] =
{
  0xFF,0xA2,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
  'A' ,0xA0,'B', 0xA1,0xE0,'E', 0xA3,0xA4,0xA5,0xA6,'K' ,0xA7,'M', 'H' ,'O' ,0xA8,
  'P' ,'C' ,'T' ,0xA9,0xAA,'X' ,0xE1,0xAB,0xAC,0xE2,0xAD,0xAE,'b',0xAF,0xB0,0xB1,
  'a' ,0xB2,0xB3,0xB4,0xE3,'e' ,0xB6,0xB7,0xB8,0xB9,0xBA,0xBB,0xBC,0xBD,'o' ,0xBE,
  'p' ,'c' ,0xBF,'y' ,0xE4,'x' ,0xE5,0xC0,0xC1,0xE6,0xC2,0xC3,0xC4,0xC5,0xC6,0xC7,
  0xFF,0xB5
};
#endif

// /MCP23x17_patch


// When the display powers up, it is configured as follows:
//
// 1. Display clear
// 2. Function set: 
//    DL = 1; 8-bit interface data 
//    N = 0; 1-line display 
//    F = 0; 5x8 dot character font 
// 3. Display on/off control: 
//    D = 0; Display off 
//    C = 0; Cursor off 
//    B = 0; Blinking off 
// 4. Entry mode set: 
//    I/D = 1; Increment by 1 
//    S = 0; No shift 
//
// Note, however, that resetting the Arduino doesn't reset the LCD, so we
// can't assume that its in that state when a sketch starts (and the
// LiquidCrystal constructor is called).

// MCP23x17_patch
/* //removed
LiquidCrystal::LiquidCrystal(uint8_t rs, uint8_t rw, uint8_t enable,
			     uint8_t d0, uint8_t d1, uint8_t d2, uint8_t d3,
			     uint8_t d4, uint8_t d5, uint8_t d6, uint8_t d7)
{
  init(0, rs, rw, enable, d0, d1, d2, d3, d4, d5, d6, d7);
}

LiquidCrystal::LiquidCrystal(uint8_t rs, uint8_t enable,
			     uint8_t d0, uint8_t d1, uint8_t d2, uint8_t d3,
			     uint8_t d4, uint8_t d5, uint8_t d6, uint8_t d7)
{
  init(0, rs, 255, enable, d0, d1, d2, d3, d4, d5, d6, d7);
}

LiquidCrystal::LiquidCrystal(uint8_t rs, uint8_t rw, uint8_t enable,
			     uint8_t d0, uint8_t d1, uint8_t d2, uint8_t d3)
{
  init(1, rs, rw, enable, d0, d1, d2, d3, 0, 0, 0, 0);
}

LiquidCrystal::LiquidCrystal(uint8_t rs,  uint8_t enable,
			     uint8_t d0, uint8_t d1, uint8_t d2, uint8_t d3)
{
  init(1, rs, 255, enable, d0, d1, d2, d3, 0, 0, 0, 0);
}

void LiquidCrystal::init(uint8_t fourbitmode, uint8_t rs, uint8_t rw, uint8_t enable,
			 uint8_t d0, uint8_t d1, uint8_t d2, uint8_t d3,
			 uint8_t d4, uint8_t d5, uint8_t d6, uint8_t d7)
{
  _rs_pin = rs;
  _rw_pin = rw;
  _enable_pin = enable;
  
  _data_pins[0] = d0;
  _data_pins[1] = d1;
  _data_pins[2] = d2;
  _data_pins[3] = d3; 
  _data_pins[4] = d4;
  _data_pins[5] = d5;
  _data_pins[6] = d6;
  _data_pins[7] = d7; 

  pinMode(_rs_pin, OUTPUT);
  // we can save 1 pin by not using RW. Indicate by passing 255 instead of pin#
  if (_rw_pin != 255) { 
    pinMode(_rw_pin, OUTPUT);
  }
  pinMode(_enable_pin, OUTPUT);
  
  if (fourbitmode)
    _displayfunction = LCD_4BITMODE | LCD_1LINE | LCD_5x8DOTS;
  else 
    _displayfunction = LCD_8BITMODE | LCD_1LINE | LCD_5x8DOTS;
  
  begin(16, 1);  
}
*/

LiquidCrystal_MCP23x17::LiquidCrystal_MCP23x17()
{
}

LiquidCrystal_MCP23x17::LiquidCrystal_MCP23x17(CMCP23x17 &IO)
{
	init(IO);
}

void LiquidCrystal_MCP23x17::init(CMCP23x17 &IO)
{
  _portA = 0;
  _pIO = &IO;

  // low byte (portA) is output (0 - LED, 1 - RS, 2 - R/W, 3 - E, 4-7 - 4-bit data)
  // high byte (portB) is input
  _pIO->pinMode16(0xff00);
  
  _displayfunction = LCD_1LINE | LCD_5x8DOTS;
  
  begin(16, 2);
}
// /MCP23x17_patch

void LiquidCrystal_MCP23x17::begin(uint8_t cols, uint8_t lines, uint8_t dotsize) {
  if (lines > 1) {
    _displayfunction |= LCD_2LINE;
  }
  _numlines = lines;
  _currline = 0;

  // for some 1 line displays you can select a 10 pixel high font
  if ((dotsize != 0) && (lines == 1)) {
    _displayfunction |= LCD_5x10DOTS;
  }

  // SEE PAGE 45/46 FOR INITIALIZATION SPECIFICATION!
  // according to datasheet, we need at least 40ms after power rises above 2.7V
  // before sending commands. Arduino can turn on way befer 4.5V so we'll wait 50
  delayMicroseconds(50000); 
  // Now we pull both RS and R/W low to begin commands
// MCP23x17_patch
/* //removed
  digitalWrite(_rs_pin, LOW);
  digitalWrite(_enable_pin, LOW);
  if (_rw_pin != 255) { 
    digitalWrite(_rw_pin, LOW);
  }
*/
  _pIO->digitalWrite16(_portA);  
// /MCP23x17_patch
  
// MCP23x17_patch
/* //removed
  //put the LCD into 4 bit or 8 bit mode
  if (! (_displayfunction & LCD_8BITMODE)) {
*/
// /MCP23x17_patch
    // this is according to the hitachi HD44780 datasheet
    // figure 24, pg 46

    // we start in 8bit mode, try to set 4 bit mode
    write4bits(0x03);
    delayMicroseconds(4500); // wait min 4.1ms

    // second try
    write4bits(0x03);
    delayMicroseconds(4500); // wait min 4.1ms
    
    // third go!
    write4bits(0x03); 
    delayMicroseconds(150);

    // finally, set to 4-bit interface
    write4bits(0x02); 
// MCP23x17_patch
/* //removed
  } else {
    // this is according to the hitachi HD44780 datasheet
    // page 45 figure 23

    // Send function set command sequence
    command(LCD_FUNCTIONSET | _displayfunction);
    delayMicroseconds(4500);  // wait more than 4.1ms

    // second try
    command(LCD_FUNCTIONSET | _displayfunction);
    delayMicroseconds(150);

    // third go
    command(LCD_FUNCTIONSET | _displayfunction);
  }
*/
// /MCP23x17_patch

  // finally, set # lines, font size, etc.
  command(LCD_FUNCTIONSET | _displayfunction);  

  // turn the display on with no cursor or blinking default
  _displaycontrol = LCD_DISPLAYON | LCD_CURSOROFF | LCD_BLINKOFF;  
  display();

  // clear it off
  clear();

  // Initialize to default text direction (for romance languages)
  _displaymode = LCD_ENTRYLEFT | LCD_ENTRYSHIFTDECREMENT;
  // set the entry mode
  command(LCD_ENTRYMODESET | _displaymode);

}

/********** high level commands, for the user! */
void LiquidCrystal_MCP23x17::clear()
{
  command(LCD_CLEARDISPLAY);  // clear display, set cursor position to zero
  delayMicroseconds(2000);  // this command takes a long time!
}

void LiquidCrystal_MCP23x17::home()
{
  command(LCD_RETURNHOME);  // set cursor position to zero
  delayMicroseconds(2000);  // this command takes a long time!
}

void LiquidCrystal_MCP23x17::setCursor(uint8_t col, uint8_t row)
{
  int row_offsets[] = { 0x00, 0x40, 0x14, 0x54 };
  if ( row >= _numlines ) {
    row = _numlines-1;    // we count rows starting w/0
  }
  
  command(LCD_SETDDRAMADDR | (col + row_offsets[row]));
}

// Turn the display on/off (quickly)
void LiquidCrystal_MCP23x17::noDisplay() {
  _displaycontrol &= ~LCD_DISPLAYON;
  command(LCD_DISPLAYCONTROL | _displaycontrol);
}
void LiquidCrystal_MCP23x17::display() {
  _displaycontrol |= LCD_DISPLAYON;
  command(LCD_DISPLAYCONTROL | _displaycontrol);
}

// Turns the underline cursor on/off
void LiquidCrystal_MCP23x17::noCursor() {
  _displaycontrol &= ~LCD_CURSORON;
  command(LCD_DISPLAYCONTROL | _displaycontrol);
}
void LiquidCrystal_MCP23x17::cursor() {
  _displaycontrol |= LCD_CURSORON;
  command(LCD_DISPLAYCONTROL | _displaycontrol);
}

// Turn on and off the blinking cursor
void LiquidCrystal_MCP23x17::noBlink() {
  _displaycontrol &= ~LCD_BLINKON;
  command(LCD_DISPLAYCONTROL | _displaycontrol);
}
void LiquidCrystal_MCP23x17::blink() {
  _displaycontrol |= LCD_BLINKON;
  command(LCD_DISPLAYCONTROL | _displaycontrol);
}

// These commands scroll the display without changing the RAM
void LiquidCrystal_MCP23x17::scrollDisplayLeft(void) {
  command(LCD_CURSORSHIFT | LCD_DISPLAYMOVE | LCD_MOVELEFT);
}
void LiquidCrystal_MCP23x17::scrollDisplayRight(void) {
  command(LCD_CURSORSHIFT | LCD_DISPLAYMOVE | LCD_MOVERIGHT);
}

// This is for text that flows Left to Right
void LiquidCrystal_MCP23x17::leftToRight(void) {
  _displaymode |= LCD_ENTRYLEFT;
  command(LCD_ENTRYMODESET | _displaymode);
}

// This is for text that flows Right to Left
void LiquidCrystal_MCP23x17::rightToLeft(void) {
  _displaymode &= ~LCD_ENTRYLEFT;
  command(LCD_ENTRYMODESET | _displaymode);
}

// This will 'right justify' text from the cursor
void LiquidCrystal_MCP23x17::autoscroll(void) {
  _displaymode |= LCD_ENTRYSHIFTINCREMENT;
  command(LCD_ENTRYMODESET | _displaymode);
}

// This will 'left justify' text from the cursor
void LiquidCrystal_MCP23x17::noAutoscroll(void) {
  _displaymode &= ~LCD_ENTRYSHIFTINCREMENT;
  command(LCD_ENTRYMODESET | _displaymode);
}

// Allows us to fill the first 8 CGRAM locations
// with custom characters
void LiquidCrystal_MCP23x17::createChar(uint8_t location, uint8_t charmap[]) {
  location &= 0x7; // we only have 8 locations 0-7
  command(LCD_SETCGRAMADDR | (location << 3));
  for (int i=0; i<8; i++) {
    write(charmap[i]);
  }
}

/*********** mid level commands, for sending data/cmds */

inline void LiquidCrystal_MCP23x17::command(uint8_t value) {
  send(value, LOW);
}

inline size_t LiquidCrystal_MCP23x17::write(uint8_t value) {
// MCP23x17_patch
/* //removed
  send(value, HIGH);
  return 1; // assume sucess
*/
#if defined(UTF8_RUSSIAN_SUPPORT)
  if (value >= 0xc0) { // !!! it should be '(value & 0xe0) == 0xc0', but it takes 12 extra bytes
    _utf8_ru_hi_bit = value & 1 ? 0x40 : 0;
    return 0;
  } else {
    if (value & 0x80) {
      value &= 0x3f;
      value = pgm_read_byte_near(_utf8_ru_table + _utf8_ru_hi_bit + value);
    }
    send(value, HIGH);
    return 1;
  }
#else
  send(value, HIGH);
  return 1; // assume sucess
#endif
// /MCP23x17_patch
}

/************ low level data pushing commands **********/

// write either command or data, with automatic 4/8-bit selection
void LiquidCrystal_MCP23x17::send(uint8_t value, uint8_t mode) {
// MCP23x17_patch
/* //removed
  digitalWrite(_rs_pin, mode);

  // if there is a RW pin indicated, set it low to Write
  if (_rw_pin != 255) { 
    digitalWrite(_rw_pin, LOW);
  }
  
  if (_displayfunction & LCD_8BITMODE) {
    write8bits(value); 
  } else {
    write4bits(value>>4);
    write4bits(value);
  }
*/
  //RW = 0; RS = mode; //RS -> bit 1, RW -> bit 2
  _portA = _portA & B11111001 | (mode << 1); 
//  _pIO->digitalWrite16(_portA); //no need to write, because next write4bits will do it 
  write4bits(value>>4);
  write4bits(value);
// /MCP23x17_patch
}

void LiquidCrystal_MCP23x17::pulseEnable(void) {
// MCP23x17_patch
/* //removed
  digitalWrite(_enable_pin, LOW);
  delayMicroseconds(1);    
  digitalWrite(_enable_pin, HIGH);
  delayMicroseconds(1);    // enable pulse must be >450ns
  digitalWrite(_enable_pin, LOW);
  delayMicroseconds(100);   // commands need > 37us to settle
*/
  _portA = _portA & B11110111;
  _pIO->digitalWrite16(_portA);  
  delayMicroseconds(1);
  _portA = _portA | B00001000;
  _pIO->digitalWrite16(_portA);  
  delayMicroseconds(1);    // enable pulse must be >450ns
  _portA = _portA & B11110111;
  _pIO->digitalWrite16(_portA);  
  delayMicroseconds(100);   // commands need > 37us to settle
// /MCP23x17_patch
}

void LiquidCrystal_MCP23x17::write4bits(uint8_t value) {
// MCP23x17_patch
/* //removed
  for (int i = 0; i < 4; i++) {
    pinMode(_data_pins[i], OUTPUT);
    digitalWrite(_data_pins[i], (value >> i) & 0x01);
  }
*/
  _portA = _portA & B00001111 | (value << 4);
//  _pIO->digitalWrite16(_portA); //no need to write, because next pulseEnable will do it
// /MCP23x17_patch

  pulseEnable();
}

// MCP23x17_patch
/* //removed
void LiquidCrystal::write8bits(uint8_t value) {
  for (int i = 0; i < 8; i++) {
    pinMode(_data_pins[i], OUTPUT);
    digitalWrite(_data_pins[i], (value >> i) & 0x01);
  }
  
  pulseEnable();
}
*/
// /MCP23x17_patch

// MCP23x17_patch
void LiquidCrystal_MCP23x17::Backlight(uint8_t state)
{
  _portA = _portA & B11111110 | state;
  _pIO->digitalWrite16(_portA);
}

uint8_t LiquidCrystal_MCP23x17::KeyPressed(uint8_t KeyMask)
{
  uint8_t tmp = ~(_pIO->digitalRead16() >> 8);
  if (KeyMask==0)
    return tmp & B00011111;
  else
    return (tmp & KeyMask) != 0; 
}

LCDMenu::LCDMenu()
{
  DisplayX = 0;
  DisplayY = 0;
  DisplayWidth = 16;
  DisplayHeight = 2;
  MenuDisplayStart = 0;
  MenuCursorPos = 0;
  KeyState = 0;
  KeyStatePrev = 0;
  EventKeyDown = 0;
  EventKeyUp = 0;
  EventKeyRepeat = 0;
  NextRepeatTime = 0;
  CharCursor = '>';
  
  pLCD = NULL; 
  pMenuItems = NULL;
  MenuItemsCount = 0;  
}

LCDMenu::LCDMenu(LiquidCrystal_MCP23x17 &lcd_, char **pMenuItems_, int MenuItemsCount_)
{
  LCDMenu();
  init(lcd_, pMenuItems_, MenuItemsCount_);
}

void LCDMenu::init(LiquidCrystal_MCP23x17 &lcd_, char **pMenuItems_, int MenuItemsCount_)
{
  pLCD = &lcd_; 
  pMenuItems = pMenuItems_;
  MenuItemsCount = MenuItemsCount_;  
}

void LCDMenu::PrintMenu()
{
  uint8_t i, len, j;
  for (i=0; i<DisplayHeight; i++)
  {
    pLCD->setCursor(DisplayX, DisplayY + i);
    if (MenuDisplayStart + i == MenuCursorPos)
      pLCD->write(CharCursor);
    else
      pLCD->write(' ');
    len = pLCD->print(pMenuItems[MenuDisplayStart + i]);
    for (j=0; j<DisplayWidth-len-1; j++) pLCD->write(' ');
  }
}

uint8_t LCDMenu::ScanKeys()
{
  unsigned long CurrentTime;
  EventKeyDown = 0;
  EventKeyUp = 0;
  EventKeyRepeat = 0;
  KeyState = pLCD->KeyPressed();
  uint8_t ChangeMask = KeyState ^ KeyStatePrev;
  KeyStatePrev = KeyState;
  if (ChangeMask)
  {
    EventKeyDown = KeyState & ChangeMask;
    EventKeyUp = ~KeyState & ChangeMask;
    NextRepeatTime = millis() + 250;
  }
  else if (KeyState)
  {
    if ((CurrentTime = millis()) > NextRepeatTime)
    {
      EventKeyRepeat = KeyState;
      NextRepeatTime = CurrentTime + 32;
    }
  }
  return KeyState;
}

void LCDMenu::DispatchKeys()
{
  uint8_t bNeedRepaint = 0;
  if ((EventKeyDown | EventKeyRepeat) & KEY_DOWN) {
    if (MenuCursorPos < MenuItemsCount-1) MenuCursorPos++;
    if (MenuCursorPos >= MenuDisplayStart + DisplayHeight) MenuDisplayStart = MenuCursorPos - DisplayHeight + 1;
    bNeedRepaint = 1;
  }
  if ((EventKeyDown | EventKeyRepeat) & KEY_UP) {
    if (MenuCursorPos > 0) MenuCursorPos--;
    if (MenuCursorPos < MenuDisplayStart) MenuDisplayStart = MenuCursorPos;
    bNeedRepaint = 1;
  }
  if (bNeedRepaint) PrintMenu();
}

uint8_t LCDMenu::Choice()
{
  PrintMenu();
  do
  {
    ScanKeys();
    DispatchKeys();
    delay(10);
  } while ((EventKeyUp & KEY_ENTER) == 0);
  return MenuCursorPos;
}
// /MCP23x17_patch
