// MCP23x17_patch
/* //removed
#ifndef LiquidCrystal_h
#define LiquidCrystal_h
*/
#ifndef LiquidCrystal_MCP23x17_h
#define LiquidCrystal_MCP23x17_h
// /MCP23x17_patch

#include <inttypes.h>
#include "Print.h"
// MCP23x17_patch
#include <MCP23x17.h>

#define KEY_RIGHT 1
#define KEY_LEFT  2
#define KEY_DOWN  4
#define KEY_UP    8
#define KEY_ENTER 16
// /MCP23x17_patch

// commands
#define LCD_CLEARDISPLAY 0x01
#define LCD_RETURNHOME 0x02
#define LCD_ENTRYMODESET 0x04
#define LCD_DISPLAYCONTROL 0x08
#define LCD_CURSORSHIFT 0x10
#define LCD_FUNCTIONSET 0x20
#define LCD_SETCGRAMADDR 0x40
#define LCD_SETDDRAMADDR 0x80

// flags for display entry mode
#define LCD_ENTRYRIGHT 0x00
#define LCD_ENTRYLEFT 0x02
#define LCD_ENTRYSHIFTINCREMENT 0x01
#define LCD_ENTRYSHIFTDECREMENT 0x00

// flags for display on/off control
#define LCD_DISPLAYON 0x04
#define LCD_DISPLAYOFF 0x00
#define LCD_CURSORON 0x02
#define LCD_CURSOROFF 0x00
#define LCD_BLINKON 0x01
#define LCD_BLINKOFF 0x00

// flags for display/cursor shift
#define LCD_DISPLAYMOVE 0x08
#define LCD_CURSORMOVE 0x00
#define LCD_MOVERIGHT 0x04
#define LCD_MOVELEFT 0x00

// flags for function set
// MCP23x17_patch
/* //removed
#define LCD_8BITMODE 0x10
#define LCD_4BITMODE 0x00
*/
// /MCP23x17_patch
#define LCD_2LINE 0x08
#define LCD_1LINE 0x00
#define LCD_5x10DOTS 0x04
#define LCD_5x8DOTS 0x00

class LiquidCrystal_MCP23x17 : public Print {
public:
// MCP23x17_patch
/* //removed
  LiquidCrystal(uint8_t rs, uint8_t enable,
		uint8_t d0, uint8_t d1, uint8_t d2, uint8_t d3,
		uint8_t d4, uint8_t d5, uint8_t d6, uint8_t d7);
  LiquidCrystal(uint8_t rs, uint8_t rw, uint8_t enable,
		uint8_t d0, uint8_t d1, uint8_t d2, uint8_t d3,
		uint8_t d4, uint8_t d5, uint8_t d6, uint8_t d7);
  LiquidCrystal(uint8_t rs, uint8_t rw, uint8_t enable,
		uint8_t d0, uint8_t d1, uint8_t d2, uint8_t d3);
  LiquidCrystal(uint8_t rs, uint8_t enable,
		uint8_t d0, uint8_t d1, uint8_t d2, uint8_t d3);

  void init(uint8_t fourbitmode, uint8_t rs, uint8_t rw, uint8_t enable,
	    uint8_t d0, uint8_t d1, uint8_t d2, uint8_t d3,
	    uint8_t d4, uint8_t d5, uint8_t d6, uint8_t d7);
*/
  LiquidCrystal_MCP23x17();
  LiquidCrystal_MCP23x17(CMCP23x17 &IO);
  void init(CMCP23x17 &IO);
// /MCP23x17_patch
    
  void begin(uint8_t cols, uint8_t rows, uint8_t charsize = LCD_5x8DOTS);

  void clear();
  void home();

  void noDisplay();
  void display();
  void noBlink();
  void blink();
  void noCursor();
  void cursor();
  void scrollDisplayLeft();
  void scrollDisplayRight();
  void leftToRight();
  void rightToLeft();
  void autoscroll();
  void noAutoscroll();
// MCP23x17_patch
  void Backlight(uint8_t state = 1);
  uint8_t KeyPressed(uint8_t KeyMask = 0);
// /MCP23x17_patch

  void createChar(uint8_t, uint8_t[]);
  void setCursor(uint8_t, uint8_t); 
  virtual size_t write(uint8_t);
  void command(uint8_t);
  
  using Print::write;
private:
  void send(uint8_t, uint8_t);
  void write4bits(uint8_t);
// MCP23x17_patch
/* //removed
  void write8bits(uint8_t);
*/
// /MCP23x17_patch
  void pulseEnable();

// MCP23x17_patch
/* //removed
  uint8_t _rs_pin; // LOW: command.  HIGH: character.
  uint8_t _rw_pin; // LOW: write to LCD.  HIGH: read from LCD.
  uint8_t _enable_pin; // activated by a HIGH pulse.
  uint8_t _data_pins[8];
*/
// /MCP23x17_patch

  uint8_t _displayfunction;
  uint8_t _displaycontrol;
  uint8_t _displaymode;

  uint8_t _initialized;

  uint8_t _numlines,_currline;

// MCP23x17_patch
  CMCP23x17 *_pIO;
  uint8_t _portA;
  uint8_t _utf8_ru_hi_bit;
// /MCP23x17_patch
};

class LCDMenu
{
  public:
    LCDMenu();
    LCDMenu(LiquidCrystal_MCP23x17 &lcd_, char **pMenuItems_, int MenuItemsCount_);
    
    void    init(LiquidCrystal_MCP23x17 &lcd_, char **pMenuItems_, int MenuItemsCount_);
    void    PrintMenu();
    uint8_t ScanKeys();
    void    DispatchKeys();
    uint8_t Choice();

    LiquidCrystal_MCP23x17 *pLCD;
    char **pMenuItems;
    uint8_t DisplayX;
    uint8_t DisplayY;
    uint8_t DisplayWidth;
    uint8_t DisplayHeight;
    uint8_t MenuDisplayStart;
    uint8_t MenuCursorPos;
    uint8_t MenuItemsCount;
    uint8_t KeyState;
    uint8_t KeyStatePrev;
    uint8_t EventKeyDown;
    uint8_t EventKeyUp;
    uint8_t EventKeyRepeat;
    unsigned long NextRepeatTime;
    char CharCursor;
};

#endif
