/*
  LiquidCrystal_MCP23x17 Library - Hello World
  see http://freeduino.ru for details
  
  sample is based on original Arduino LiquidCrystal sample
  with only difference, that we use MCP23x17-based shield
  for interfacing with LCD display
*/
//include base class code
#include <MCP23x17.h>

//For SPI version of shield we include SPI.h and MCP23S17.h:
#include <SPI.h>
#include <MCP23S17.h>

////For I2C version of shield we include Wire.h and MCP23017.h:
//#include <Wire.h>
//#include <MCP23017.h>

//include the library code
#include <LiquidCrystal_MCP23x17.h>

//For SPI version of shield we create CMCP23S17 object:
CMCP23S17 MCP;

////For I2C version of shield we create CMCP20S17 object:
//CMCP23017 MCP;

//LCD object
LiquidCrystal_MCP23x17 lcd;

void setup() {
  //For SPI version of shield we configure SPI bus, and MCP object with CS line (10) and address (0)
  SPI.begin();
  MCP.init(10, 0);

//  //For I2C version of shield we configure I2C bus, and MCP object with address (0)
//  Wire.begin();      //TWBR = 12;  // <- uncomment this for 400kHz I2C
//  MCP.init(0);
  
  //here we configure LCD object to work through specified MCP object
  lcd.init(MCP);
  //...and turn on backlight
  lcd.Backlight(1);

  //...all the following code will be the same for original LiquidCrystal library and MCP23x17-based
  
  // set up the LCD's number of columns and rows: 
  lcd.begin(16, 2);
  // Print a message to the LCD.
  lcd.print("hello, world!");
}

void loop() {
  // set the cursor to column 0, line 1
  // (note: line 1 is the second row, since counting begins with 0):
  lcd.setCursor(0, 1);
  // print the number of seconds since reset:
  lcd.print(millis()/1000);
}
