/*
  LiquidCrystal_MCP23x17 Library - Hello World
  see http://freeduino.ru for details
*/
//include base class code
#include <MCP23x17.h>

//For SPI version of shield we include SPI.h and MCP23S17.h:
#include <SPI.h>
#include <MCP23S17.h>
////For I2C version of shield we include Wire.h and MCP23017.h:
//#include <Wire.h>
//#include <MCP23017.h>

//include the library code
#include <LiquidCrystal_MCP23x17.h>

char *MenuItems_Main[] = {
  "Backlight",
  "Cursor",
  "Language"
};
char *MenuItems_Main_ru[] = {
  "Подсветка",
  "Курсор",
  "Язык/Language"
};

char *MenuItems_Backlight[] = {
  "Backlight OFF",
  "Backlight ON"
};
char *MenuItems_Backlight_ru[] = {
  "Выкл. подсветку",
  "Вкл. подсветку"
};

char *MenuItems_Cursor[] = {
  ">",
  "*",
  "+",
  "-",
  ")",
  "#",
  "]",
};

char *MenuItems_Language[] = {
  "English",
  "Русский"
};

//For SPI version of shield we create CMCP23S17 object:
CMCP23S17 MCP;
////For I2C version of shield we create CMCP20S17 object:
//CMCP23017 MCP;
//LCD object
LiquidCrystal_MCP23x17 lcd;
//Menu objects
LCDMenu Menu_Main;
LCDMenu Menu_Backlight;
LCDMenu Menu_Cursor;
LCDMenu Menu_Language;

void setup() {
  //For SPI version of shield we configure SPI bus, and MCP object with CS line (10) and address (0)
  SPI.begin();
  MCP.init(10, 0);
//  //For I2C version of shield we configure I2C bus, and MCP object with address (0)
//  Wire.begin();      //TWBR = 12;  // <- uncomment this for 400kHz I2C
//  MCP.init(0);

  //here we configure LCD object to work through specified MCP object
  lcd.init(MCP);
  //...and turn on backlight
  lcd.Backlight(1);
  lcd.begin(16, 2);

  //here we configure Menu objects with items  
  Menu_Main.init(lcd, MenuItems_Main, 3);
  Menu_Backlight.init(lcd, MenuItems_Backlight, 2);
  Menu_Cursor.init(lcd, MenuItems_Cursor, 7);
  Menu_Language.init(lcd, MenuItems_Language, 2);
}

void loop() {
  uint8_t i_1, i_2;
  
  i_1 = Menu_Main.Choice();
  switch (i_1)
  {
    case 0:
      i_2 = Menu_Backlight.Choice();
      lcd.Backlight(i_2);
      break;
    case 1:
      i_2 = Menu_Cursor.Choice();
      Menu_Main.CharCursor = MenuItems_Cursor[i_2][0];
      Menu_Backlight.CharCursor = MenuItems_Cursor[i_2][0];
      Menu_Cursor.CharCursor = MenuItems_Cursor[i_2][0];
      Menu_Language.CharCursor = MenuItems_Cursor[i_2][0];
      break;
    case 2:
      i_2 = Menu_Language.Choice();
      if (i_2==0)
      {
        Menu_Main.pMenuItems = MenuItems_Main;
        Menu_Backlight.pMenuItems = MenuItems_Backlight;
      }
      else
      {
        Menu_Main.pMenuItems = MenuItems_Main_ru;
        Menu_Backlight.pMenuItems = MenuItems_Backlight_ru;
      }
      break;
  }
}
